(******************************************************************************)
(*                                                                            *)
(*          Testprogramm fr Simatic S7 Kopplung ber PPI - Kabel             *)
(*       Dieses Programm wurde mit einer S7-200 CPU 212 R1.1 getestet         *)
(*       Derzeit ist nicht sicher,das der Umgang mit der SPS korrekt ist      *)
(*       und es wird keinerlei Gewhr auf korrekte Funktion gegeben. Dieses   *)
(*       Testprogramm ist so wie es ist,eine Benutzung kann nur auf Ihr       *)
(*       eigenes Risiko erfolgen.Haftung und Gewhrleistung AUSGESCHLOSSEN    *)
(*									      *)
(******************************************************************************)


unit TestMain;

{------------------------------------------------------------------------------}

interface

{------------------------------------------------------------------------------}

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

{--------------------------------------------------------------------------}

const
  Stationsnummer = 2;
  Hostnummer     = 0;

  Port           = 1;
  Baudrate       = CBR_9600;

  S7Header : Array[0..21] of Byte =  ($68, $1B, $1B, $68, Stationsnummer + Hostnummer, $00,
   $6C, $32, $01, $00, $00, $00, $00, $00, $0E, $00, $00, $04, $01, $12, $0A, $10);

  S7GetCPUTyp : Array[0..10] of Byte =
   ($02, $00, $10 , $00, $00, $03, $00, $00, $00, $F5, $16);

  S7Quittung : Array[0..5] of Byte = ($10, StationsNummer + HostNummer, $00, $5C, $5E, $16);

  S7GetEW0 : Array[0..10] of Byte =
   ($04, $00, $01, $00, $00, $81, $00, $00, $00, $74 + Stationsnummer + HostNummer, $16);

  S7GetAW0 : Array[0..10] of Byte =
   ($04, $00, $01, $00, $00, $82, $00, $00, $00, $75 + Stationsnummer + HostNummer, $16);

  S7GetMW0 : Array[0..10] of Byte =
   ($04, $00, $01, $00, $00, $83, $00, $00, $00, $76 + Stationsnummer + HostNummer, $16);

  S7GetVW0 : Array[0..10] of Byte =
   ($04, $00, $01, $00, $01, $84, $00, $00, $00, $78 + Stationsnummer + HostNummer, $16);

  S7GetTW0 : Array[0..10] of Byte =
   ($04, $00, $01, $00, $00, $81, $00, $00, $00, $74 + Stationsnummer + HostNummer, $16);

  S7GetZW0 : Array[0..10] of Byte =
   ($04, $00, $01, $00, $00, $82, $00, $00, $00, $75 + Stationsnummer + HostNummer, $16);


  S7CPUStop : Array[0..34] of Byte = ($68, $1D, $1D, $68, Stationsnummer + HostNummer,
   $00, $7C, $32, $01, $00, $00, $00, $00, $00, $10, $00, $00,
   $29, $00, $00, $00, $00, $00, $09, $50, $5F, $50, $52, $4F,
   $47, $52, $41, $4D, $B8 + Stationsnummer + HostNummer, $16);

  S7CPURun : Array[0..38] of Byte = ($68, $21, $21, $68, Stationsnummer + HostNummer,
   $00, $7C, $32, $01, $00, $00, $00, $00, $00, $14, $00, $00,
   $28, $00, $00, $00, $00, $00, $00, $FD, $00, $00, $09, $50,
   $5F, $50, $52, $4F, $47, $52, $41, $4D, $B8 + StationsNummer + HostNummer, $16);

{--------------------------------------------------------------------------}

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Timer1: TTimer;
    Label5: TLabel;
    Label6: TLabel;
    Button1: TButton;
    Button2: TButton;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    FCID         : THandle ;
    FDCB         : TDCB ;
    FCTO         : TCommTimeOuts;
    OverlapBlock : TOverlapped;
    dwDummy      : DWord;
    PortOpened   : Boolean;
    Bytebuffer   : Array[0..10240] of Byte;

    function OpenCOM(No: Byte) : Boolean;
    function CloseCOM : Boolean;
    function ReadData(var DataBuffer; Anzahl : DWord) : Boolean;
    function WriteData(var DataBuffer; Anzahl : DWord) : Boolean;
    function GetCPUType: String;
    function GetEW0: Integer;
    function GetVW0: Integer;
    function GetAW0: Integer;
    function GetMW0: Integer;
    function GetTW0: Integer;
    function GetZW0: Integer;
    procedure RunCPU;
    procedure StopCPU;
  public
    { Public-Deklarationen}
  end;

{------------------------------------------------------------------------------}

var
  Form1: TForm1;

{------------------------------------------------------------------------------}

implementation

{------------------------------------------------------------------------------}

{$R *.DFM}

{------------------------------------------------------------------------------}

procedure TForm1.FormCreate(Sender: TObject);
var sDummy : String;
begin
  PortOpened := OpenCOM(Port);
  sDummy := GetCPUType;
  if sDummy <> '' then
    Label1.Caption := sDummy
  else
    Label1.Caption := 'Lesefehler';
end;

{------------------------------------------------------------------------------}

procedure TForm1.FormDestroy(Sender: TObject);
begin
  if PortOpened then
    CloseCOM;
end;

{------------------------------------------------------------------------------}

function TForm1.OpenCOM(No: Byte) : Boolean;
var acDummy  : Array[0..4] of Char;
begin
  OverlapBlock.Offset := 0;
  OverlapBlock.OffsetHigh := 0;
  OverlapBlock.Internal := 0;
  OverlapBlock.InternalHigh := 0;
  OverlapBlock.hEvent :=  CreateEvent(NIL, FALSE, TRUE, pChar('S7_Event')) ;
  StrPcopy(acDummy, 'COM' + IntToStr(No));
  FCID := CreateFile(acDummy, (GENERIC_READ or GENERIC_WRITE), 0, NIL, OPEN_EXISTING, FILE_FLAG_OVERLAPPED, 0);
  if FCID <> INVALID_HANDLE_VALUE then begin
    Result := True;
    SetupComm (FCID, 1024, 1024);
    FDCB.DCBLength := SizeOf(TDCB);
    FDCB.BaudRate := Baudrate;
    FDCB.ByteSize := 8;
    FDCB.Parity := EVENPARITY;
    FDCB.StopBits := ONESTOPBIT;
    FDCB.Flags := $0001;
    SetCommState(FCID, FDCB);
    FCTO.ReadIntervalTimeout := 0;
    FCTO.ReadTotalTimeoutMultiplier := 0;
    FCTO.ReadTotalTimeoutConstant := 1000;
    FCTO.WriteTotalTimeoutMultiplier := 0;
    FCTO.WriteTotalTimeoutConstant := 1000;
    SetCommTimeouts(FCID, FCTO);
    EscapeCommFunction(FCID, SETRTS);
    EscapeCommFunction(FCID, SETDTR);
  end else
    Result := False;
end;

{------------------------------------------------------------------------------}

function TForm1.CloseCOM : Boolean;
begin
  EscapeCommFunction(FCID, CLRRTS);
  EscapeCommFunction(FCID, CLRDTR);
  SetCommMask(FCID, 0);
  Result := CloseHandle(FCID);
end;

{------------------------------------------------------------------------------}

function TForm1.ReadData(var DataBuffer; Anzahl : DWord) : Boolean;
var Res  : Dword;
begin
  Result := False;
  if not ReadFile(FCID, DataBuffer, Anzahl, dwDummy, @OverlapBlock) then begin
    Res := WaitForSingleObject(OverlapBlock.hEvent, 1000);
    case Res of
      WAIT_OBJECT_0 : begin
                        ResetEvent(OverlapBlock.hEvent);
                        OverlapBlock.Offset := 0;
                        OverlapBlock.OffsetHigh := 0;
                        Result := True;
                      end;
      WAIT_TIMEOUT :  begin
                        ResetEvent(OverlapBlock.hEvent);
                        OverlapBlock.Offset := 0;
                        OverlapBlock.OffsetHigh := 0;
                        Result := False;
                      end;
    end;
  end;
end;

{------------------------------------------------------------------------------}

function TForm1.WriteData(var DataBuffer; Anzahl : DWord) : Boolean;
var Res : DWord;
begin
  Result := True;
  if not WriteFile(FCID, DataBuffer, Anzahl, dwDummy, @OverlapBlock) then begin
    Result := False;
    Res := WaitForSingleObject(OverlapBlock.hEvent, 1000);
    if  Res <> 0 then
      Exit
    else begin
      ResetEvent(OverlapBlock.hEvent);
      OverlapBlock.Offset := 0;
      OverlapBlock.OffsetHigh := 0;
    end;
  end;
end;

{------------------------------------------------------------------------------}

function TForm1.GetCPUType: String;
var bDummy : Byte;
begin
  Result := '';
  if PortOpened then begin
    S7Header[6] := $6C;
    WriteData(S7Header, SizeOf(S7Header));
    WriteData(S7GetCPUTyp, SizeOf(S7GetCPUTyp));
    ReadData(ByteBuffer, 1);
    if ByteBuffer[0] = $E5 then begin
      WriteData(S7Quittung, SizeOf(S7Quittung));
      ReadData(ByteBuffer, 43);
      for bDummy := 25 to 39 do
        Result := Result + Char(ByteBuffer[bDummy]);
    end;
  end;
end;

{------------------------------------------------------------------------------}

function TForm1.GetEW0: Integer;
begin
  Result := -1;
  if PortOpened then begin
    S7Header[6] := $7C;
    WriteData(S7Header, SizeOf(S7Header));
    WriteData(S7GetEW0, SizeOf(S7GetEW0));
    ReadData(ByteBuffer, 1);
    if ByteBuffer[0] = $E5 then begin
      WriteData(S7Quittung, SizeOf(S7Quittung));
      ReadData(ByteBuffer, 29);
      Result := ByteBuffer[26] SHL 8 + ByteBuffer[25];
    end;
  end;
end;

{------------------------------------------------------------------------------}

function TForm1.GetVW0: Integer;
begin
  Result := -1;
  if PortOpened then begin
    S7Header[6] := $7C;
    WriteData(S7Header, SizeOf(S7Header));
    WriteData(S7GetVW0, SizeOf(S7GetVW0));
    ReadData(ByteBuffer, 1);
    if ByteBuffer[0] = $E5 then begin
      WriteData(S7Quittung, SizeOf(S7Quittung));
      ReadData(ByteBuffer, 29);
      Result := ByteBuffer[25] SHL 8 + ByteBuffer[26];
    end;
  end;
end;

{------------------------------------------------------------------------------}

function TForm1.GetAW0: Integer;
begin
  Result := -1;
  if PortOpened then begin
    S7Header[6] := $7C;
    WriteData(S7Header, SizeOf(S7Header));
    WriteData(S7GetAW0, SizeOf(S7GetAW0));
    ReadData(ByteBuffer, 1);
    if ByteBuffer[0] = $E5 then begin
      WriteData(S7Quittung, SizeOf(S7Quittung));
      ReadData(ByteBuffer, 29);
      Result := ByteBuffer[25] SHL 8 + ByteBuffer[26];
    end;
  end;
end;

{------------------------------------------------------------------------------}

function TForm1.GetMW0: Integer;
begin
  Result := -1;
  if PortOpened then begin
    S7Header[6] := $7C;
    WriteData(S7Header, SizeOf(S7Header));
    WriteData(S7GetMW0, SizeOf(S7GetMW0));
    ReadData(ByteBuffer, 1);
    if ByteBuffer[0] = $E5 then begin
      WriteData(S7Quittung, SizeOf(S7Quittung));
      ReadData(ByteBuffer, 29);
      Result := ByteBuffer[25] SHL 8 + ByteBuffer[26];
    end;
  end;
end;

{------------------------------------------------------------------------------}

function TForm1.GetTW0: Integer;
begin
  Result := -1;
  if PortOpened then begin
    S7Header[6] := $7C;
    WriteData(S7Header, SizeOf(S7Header));
    WriteData(S7GetTW0, SizeOf(S7GetTW0));
    ReadData(ByteBuffer, 1);
    if ByteBuffer[0] = $E5 then begin
      WriteData(S7Quittung, SizeOf(S7Quittung));
      ReadData(ByteBuffer, 29);
      Result := ByteBuffer[25] SHL 8 + ByteBuffer[26];
    end;
  end;
end;

{------------------------------------------------------------------------------}

function TForm1.GetZW0: Integer;
begin
  Result := -1;
  if PortOpened then begin
    S7Header[6] := $7C;
    WriteData(S7Header, SizeOf(S7Header));
    WriteData(S7GetZW0, SizeOf(S7GetZW0));
    ReadData(ByteBuffer, 1);
    if ByteBuffer[0] = $E5 then begin
      WriteData(S7Quittung, SizeOf(S7Quittung));
      ReadData(ByteBuffer, 29);
      Result := ByteBuffer[25] SHL 8 + ByteBuffer[26];
    end;
  end;
end;

{------------------------------------------------------------------------------}

procedure TForm1.StopCPU;
begin
  if PortOpened then begin
    WriteData(S7CPUStop, SizeOf(S7CPUStop));
    ReadData(ByteBuffer, 1);
    if ByteBuffer[0] = $E5 then begin
      WriteData(S7Quittung, SizeOf(S7Quittung));
      ReadData(ByteBuffer, 23);
    end;
  end;
end;

{------------------------------------------------------------------------------}

procedure TForm1.RunCPU;
begin
  if PortOpened then begin
    WriteData(S7CPURun, SizeOf(S7CPURun));
    ReadData(ByteBuffer, 1);
    if ByteBuffer[0] = $E5 then begin
      WriteData(S7Quittung, SizeOf(S7Quittung));
      ReadData(ByteBuffer, 23);
    end;
  end;
end;

{------------------------------------------------------------------------------}

procedure TForm1.Timer1Timer(Sender: TObject);
var  iDummy : Integer;
begin
  iDummy := GetEW0;
  if iDummy > -1 then
    Label4.Caption := IntToStr(iDummy) + ' DEZ     ' + IntToHex(iDummy, 4) + ' HEX'
  else
    Label4.Caption := 'Lesefehler';
  iDummy := GetVW0;
  if iDummy > -1 then
    Label6.Caption := IntToStr(iDummy) + ' DEZ     ' + IntToHex(iDummy, 4) + ' HEX'
  else
    Label6.Caption := 'Lesefehler';
  iDummy := GetAW0;
  if iDummy > -1 then
    Label8.Caption := IntToStr(iDummy) + ' DEZ     ' + IntToHex(iDummy, 4) + ' HEX'
  else
    Label8.Caption := 'Lesefehler';
  iDummy := GetMW0;
  if iDummy > -1 then
    Label10.Caption := IntToStr(iDummy) + ' DEZ     ' + IntToHex(iDummy, 4) + ' HEX'
  else
    Label10.Caption := 'Lesefehler';
  iDummy := GetTW0;
  if iDummy > -1 then
    Label12.Caption := IntToStr(iDummy) + ' DEZ     ' + IntToHex(iDummy, 4) + ' HEX'
  else
    Label12.Caption := 'Lesefehler';
  iDummy := GetZW0;
  if iDummy > -1 then
    Label14.Caption := IntToStr(iDummy) + ' DEZ     ' + IntToHex(iDummy, 4) + ' HEX'
  else
    Label14.Caption := 'Lesefehler';
end;

{------------------------------------------------------------------------------}

procedure TForm1.Button1Click(Sender: TObject);
begin
  StopCPU;
end;

{------------------------------------------------------------------------------}

procedure TForm1.Button2Click(Sender: TObject);
begin
  RunCPU;
end;

end.
